import '@host';

import './app.scss';

// Component dependencies
import '../head/head-component';
import '../body/body-component';
import '../side-menu/side-menu-component';

import { Component } from '../../scripts/decorators/component';
import { View }      from '../../scripts/decorators/view';
import { State }     from '../../scripts/decorators/state';
import { inject }    from '../../scripts/decorators/inject';
import { App }       from './app';

@State({
  name: 'app',
  abstract: true,
  url: null,
  attachToView: 'app'
})

@Component({
  selector: 'app'
})

@View({
  template: require('./app.html')
})

/**
 * @class AppComponent
 */
export class AppComponent {
  @inject
  app: App;

  @inject
  $rootScope: any;

  constructor() {
    // Initialize
  }

  ionicGoBack() {
    this.$rootScope.$ionicGoBack();
  }
}
