import { Service }  from '../../scripts/decorators/service';
import { inject }   from '../../scripts/decorators/inject';
import * as _       from 'lodash';

@Service('head')

/**
 * @class Head
 * @service head
 */
export class Head {
  @inject
  private $rootScope: angular.IRootScopeService;

  // TODO: config.projectName (which comes from pakcage.json)
  tagDefaults = {
    description: 'Ionic Boilerplate'
  };

  tags: any = {};

  meta = {
    description: 'Ionic Boilerplate',

    viewport: [
      'width=device-width',
      'initial-scale=1.0',
      'maximum-scale=1.0',
      'user-scalable=no'
    ].join()
  };

  constructor() {
    this.$rootScope.$on('$locationChangeSuccess', () => {
      this.resetMetaTags();
    });
  }

  resetMetaTags() {
    // Do something
  }

  title() {
    // TODO: pull from configs
    let title = '';

    if (this.tags.title) {
      title = title + ' | ' + this.tags.title;
    }

    return title;
  }

  resetTags() {
    return this.tags = {};
  }

  // TODO: automatic default of page is header title
  //       or in generator have default "Head.set title: <%= humanName %>"

  set(options: any) {
    return _.extend(this.tags, options);
  }
}
