import { Config } from '../decorators/config';
import { inject } from '../decorators/inject';

@Config

/**
 * @class PerformanceConfigs
 * @description configure performance optimizations
 */
export class CompileConfigs {
  @inject
  $compileProvider: angular.ICompileProvider;

  @inject
  $httpProvider: angular.IHttpProvider;

  @inject
  // Can't find angular type definition for $provide
  $provide: any;

  @inject
  config: any;

  constructor() {
    this.setConfigs();
  }

  /**
   * Set location configs
   */
  setConfigs() {
    const env = this.config.env;
    const enableDebugInfo = _.contains(['development', undefined], env);

    // TODO: use config for this with defaults so can be configured
    // per environment
    this.$compileProvider.debugInfoEnabled(enableDebugInfo);

    // Always use this, always helps
    this.$httpProvider.useApplyAsync(true);
  }
}
