import { Directive } from '../decorators/directive';

// TODO: maybe redo this to be one directive
// that for load-animation and bg-load-animation (does bg image
// unless 'img' or 'iframe' tag)
// and instead make it general use
@Directive('bgLoadAnimation')
export class BgLoadAnimationDirective implements angular.IDirective {
  link(scope: ng.IScope, element: ng.IAugmentedJQuery, attrs: any) {
    const className = attrs.bgLoadAnimation || 'fade';
    element.addClass(className);

    _.defer(() => {
      const bgImage = getComputedStyle(element[0]).backgroundImage;
      const img = <HTMLImageElement>document.createElement('img');

      angular.element(img).on('load', () => {
        const regex = /url\(["']?(.+?)["']?\)/;
        const match = regex.exec(bgImage);
        img[0].src = match[1];
      });
    });
  }
}
