import { Directive } from '../decorators/directive';

@Directive('ngModelSuffix')

/**
 * Allows editing of javascript objects as text
 */
export class NgModelSuffixDirective implements angular.IDirective {
  restrict = 'A';
  require = 'ngModel';

  scope = {
    ngModelSuffix: '='
  };

  link(scope: any, element: ng.IAugmentedJQuery, attr: ng.IAttributes, ngModel: ng.INgModelController) {
    ngModel.$parsers.push((input: string) => {
      return input + (scope.ngModelSuffix || '');
    });

    ngModel.$formatters.push((data = '') => {
      const regex = new RegExp(_.escapeRegExp(scope.ngModelSuffix) + '$');
      return data.replace(regex, '');
    });
  }
}
