import { Directive } from '../decorators/directive';

const Pikaday = require('pikaday/pikaday.js');

@Directive('pikaday')
export class PikadayDirective implements angular.IDirective {
  require = 'ngModel';

  rectrict = 'A';

  scope = {
    date: '=ngModel'
  };

  link(scope: any, element: ng.IAugmentedJQuery, attrs: any, ngModel: angular.INgModelController) {
    const options: any = {
      field: element[0],
      defaultDate: scope.date,
      format: 'D MMM YYYY' // TODO: get from configs
    };

    _.extend(options, attrs.pikaday ? scope.$parent.$eval(attrs.pikaday) : {});

    const onSelect: Function = options.onSelect;

    options.onSelect = (date: any) => {
      scope.date = date;
      ngModel.$setViewValue(date);

      if (_.isFunction(onSelect)) {
        onSelect();
      }

      if (!scope.$$phase) {
        scope.$apply();
      }
    };

    const picker: any = new Pikaday(options);

    scope.$on('$destroy', function() {
      picker.destroy();
    });
  }
}
