import { Service } from '../decorators/service';
// import { inject }  from '../decorators/inject';
import * as _      from 'lodash';

declare const config: any;

@Service('component')

/**
 * @class ComponentService
 */
export class Component {
  // @inject
  // private $state: angular.ui.IStateService;

  // @inject
  // private config: any;

  // Helper to get a template for a component by name
  //
  // e.g.
  //   ComponentClass.template 'kitchenSink', title: 'Something'
  //   returns: '<kitchen-sink title="Something"></kitchen-sink>'

  template(name: string, options?: any): string {
    name = _.kebabCase(name);

    const el = document.createElement(name);

    for (const key in options) {
      el.setAttribute(key, options[key]);
    }

    const html = el.outerHTML;

    return html;
  }

  // TODO: move to view.ts service
  viewTemplate(name: string, options?: any): string {
    const template = this.template(name, options);
    let titleName: string = options && options.title;
    titleName = titleName || _.startCase(name);

    // const states = this.$state.get();
    const thisState = _.find(config.routes, (state: any) => {
      return state.component === name;
    });

    // TODO: configure in state settings
    const hideNavBar = Boolean(thisState && thisState.hideNavBar);

    return `
      <ion-view hide-nav-bar="${hideNavBar}" title="${titleName}">
        <ion-content>
          ${template}
        </ion-content>
      </ion-view>
    `;
  }
}
